/*************************************************************************/
/*************************************************************************/
/* H. Timucin OZDEMIR                                                    */
/* Date : April, 1997                                                    */
/* File Name : OperationList.cc                                          */
/*************************************************************************/
/*************************************************************************/

#include <iostream.h>
#include <stdlib.h>
#include <stdio.h>
#include "OperationList.h"
#include "Operation.h"

OperationList::~OperationList()
{  
   if((index>0)&&(OperList!=NULL)) delete [] OperList;
   if((index>0)&&(Mark!=NULL)) delete [] Mark;

}// end of destructor

OperationList::OperationList()
{ 
   JobNumber = -1;
   index     = 0;
   OperList  = NULL;
   Mark  = NULL;
   MaxOpNumber = -1;

}// end of constructor

OperationList::OperationList(const OperationList& RHS)
{ 
   JobNumber = RHS.JobNumber;
   index     = RHS.index;
   OperList  = new Operation[index];
   Mark  = new int[index];

   for(int i=0;i<index;i++)
   {  OperList[i] = RHS.OperList[i];
      Mark[i] = RHS.Mark[i];
   }// end of if

   MaxOpNumber = RHS.MaxOpNumber;

}// end of COPY constructor

OperationList::OperationList(int _JobNumber, int MaxOperationNumber)
{  
   JobNumber = _JobNumber;
   index     = 0;
   //OperList  = new Operation[MaxOperationNumber];
   OperList  = NULL;
   //Mark      = new int[MaxOperationNumber];
   Mark      = NULL;
   MaxOpNumber = MaxOperationNumber;

}// end of constructor

/*
// Adds operation at the end of the list
*/

OperationList::addOperation(Operation newOp)
{  int i;

   if(index<MaxOpNumber)
   {  
      Operation *temp = new Operation[index+1]; 
      for(i=0;i<index;i++) temp[i] = OperList[i];

      temp[i] = newOp;
      if(index) delete [] OperList;
      if(index) delete [] Mark;

      /*OperList = new Operation[index+1];
      for(i=0;i<index;i++) OperList[i]=temp[i];
      OperList[i] = newOp;
      */
      index++;

      Mark = new int[index];
      for(i=0;i<index;i++) Mark[i] = 1;

      OperList = &(temp[0]);
      //delete [] temp;

   }
   else cout << "index is greater than MaxOpNumber " << endl;

   return index;

}// end of addOperation()

/*
//  Returns the number of operations in the operationlist object.
*/

OperationList::getNumberOfOperation()
{  return index;
}// end of getNumberOfOperation()

/*
//  Sets the maximum number of operations for this object.
*/

OperationList::setNumberOfOperation(int k)
{  MaxOpNumber = k; 
   return k;
}// end of getNumberOfOperation()

/*
//  Returns the Job ID of this operationList object.
*/

OperationList::getJobNumber()
{  return JobNumber;
}// end of getJobNumber()

/*
// returns the Operation according to given indx
*/

Operation* OperationList::getOperation(int indx)
{  return (indx>=0&&indx<index?&OperList[indx]:(Operation*)NULL);
}// end of getOperation()

/*
//  Deletes the operation given with index from the operation list.
*/

OperationList::deleteOperation(int indx)
{  
   //cout << " in OperationList::deleteOperation index " << index << endl;
   if(indx>=0 && indx<index) 
   {  
      if(index>1)
      {  int i,j;
	 int *newMark = new int[index-1];
	 Operation * newOpList = new Operation[index-1];

	  for(i=0,j=0;i<index;i++)
	    if(i!=indx)
	    {  newOpList[j] = OperList[i];
	       newMark[j]   = 1;
	       j++;
	    }

	    delete [] OperList;
	    delete [] Mark;

	    OperList = &(newOpList[0]);
	    Mark = &(newMark[0]);
	    index--;
      }
      else
       {  delete [] OperList;
	  delete [] Mark;
	  OperList = NULL;
	  Mark = NULL;
	  index = 0;
       }
   }// end of if

   //cout << " I am out of OperationList::deleteOperation index " << index << endl;

   return (indx>=0 && indx<index) ;

}// end of getOperation()

void OperationList::shrink()
{  int i, j;
   int *newMark = new int[index];
   Operation * newOpList = new Operation[index];

   cout << " in OperationList::shrink() " << endl;
   j=0;
   for(i=0;i<index;i++) if(Mark[i]!=0) j +=1;
   newMark = new int[j];
   newOpList = new Operation[j];
 
   cout << " after allocation " << endl;

   j=0;
   for(i=0;i<index;i++)
     if(Mark[i])
     {  newOpList[j] = OperList[i];
	newMark[j]   = 1; 
	j++;
     }

   cout << " before deleteS index " << index << endl;
   
   if(index>0)
   {  cout << " delete [] Mark " << endl; 
      delete [] Mark;
      cout << " delete [] OperList " << endl; 
      delete [] OperList;
      cout << " after delete [] OperList " << endl; 
   }// end of if

   cout << " after deleteS " << endl;

   index = j;

   Mark = newMark;
   OperList = newOpList;

   cout << " after OperationList::shrink() " << endl;

}// end of shrink()

/*
// gets the operation according to FacilityIndex
*/

Operation * OperationList::getOperationWithFacilityIndex(int FacilityIndx)
{  
   int i=0, notFound=1;
   
   while( i<index && notFound )
      if(Mark[i]&&OperList[i].getFacilityNumber()==FacilityIndx) notFound = 0;
      else i++;

   return (notFound?NULL:&OperList[i]);

}// end of getOperationWithFacilityIndex()

/*
// gets the operation according to OperationNumber
*/

Operation * OperationList::getOperationWithIndex(int OperationIndex)
{  
   int i=0, notFound=1;
   
   while( i<index && notFound )
      if(Mark[i]&&OperList[i].getOperationNumber()==OperationIndex) notFound = 0;
      else i++;

   return (notFound?NULL:&OperList[i]);

}// end of getOperationWithFacilityIndex()

OperationList::getOperationIndex(Operation newOp)
{  int i, indx=-1; 
   for(i=0;i<index && indx == -1;i++)
     if(Mark[i]&&(newOp.getOperationNumber()==OperList[i].getOperationNumber())
        &&(newOp.getFacilityNumber()==OperList[i].getFacilityNumber()))
                indx = i;
      
   return indx;

}// end of getOperationIndex()

void OperationList::print()
{  int i;

   for(i=0;i<index;i++)
     if(Mark[i])
     {  cout << i << " : " << OperList[i].getFacilityNumber() << " , " ;
        cout << OperList[i].getElapsedTime() << " - ";
     }// end of if
   cout << endl;

}// end of print()

ostream & operator <<(ostream &os, const OperationList &Olist)
{  
   int i;

   os << Olist.JobNumber << ":";

   for(i=0;i<Olist.index-1;i++) 
      if(Olist.Mark[i]) os << (i%4==0?"\n\t":" ") << Olist.OperList[i] << " , ";

   if(i<Olist.index && Olist.Mark[i]) 
      os << (i%4==0?"\n\t":" ") << Olist.OperList[i] ;
   return os; 

}// end of operator <<

OperationList OperationList::operator =(const OperationList &OList)
{
   JobNumber   = OList.JobNumber;
   MaxOpNumber = OList.MaxOpNumber;

   if(index)
   {  delete [] OperList;
      delete [] Mark;
   }// end of if
   
   index       = OList.index;

   OperList = new Operation[index];
   Mark     = new int[index];

   for(int i=0;i<index;i++) 
   {  OperList[i] = OList.OperList[i];
      Mark[i] = OList.Mark[i];
   }// end of for

   return (*this);

}// end of operator =

OperationList::operator ==(const OperationList &OList)
{  int ret = 0;
   
   ret = (JobNumber==OList.JobNumber && index == OList.index &&
          MaxOpNumber == OList.MaxOpNumber );

   for(int i=0;i<index && ret;i++) 
	ret = (OperList[i] == OList.OperList[i] && Mark[i] == OList.Mark[i]);

   return ret;

}// end of operator ==

